data{
    int N;
    array[N] int F;
    array[N] int Xr1;
    array[N] int Xr2;
    array[N] int Xr3;
    array[N] int Xc1;
    array[N] int Xc2;
    array[N] int Xc3;
}
parameters{
    real mu;
    real a2;
    real a3;
    real b2;
    real b3;
    real g22;
    real g23;
    real g32;
    real g33;
}
transformed parameters{
    array[N] real Lmbd;
    array[N] real LogLmbd;
    for (i in 1:N)
        LogLmbd[i] = mu + a2 * Xr2[i] + a3 * Xr3[i]
                        + b2 * Xc2[i] + b3 * Xc3[i]
                        + g22 * Xr2[i] * Xc2[i] + g23 * Xr2[i] * Xc3[i]
                        + g32 * Xr3[i] * Xc2[i] + g33 * Xr3[i] * Xc3[i];
    for (i in 1:N)
        Lmbd[i] = exp(LogLmbd[i]);
}
model{
    mu ~ normal(0.0, 10.0);
    a2 ~ normal(0.0, 10.0);
    a3 ~ normal(0.0, 10.0);
    b2 ~ normal(0.0, 10.0);
    b3 ~ normal(0.0, 10.0);
    g22 ~ normal(0.0, 10.0);
    g23 ~ normal(0.0, 10.0);
    g32 ~ normal(0.0, 10.0);
    g33 ~ normal(0.0, 10.0);
    for (i in 1:N)
        F[i] ~ poisson(Lmbd[i]);
}
